function Ang=Cart2Ang(Cart,l1,l2)
 
% Cartesian coordinates
x=Cart(:,1);
y=Cart(:,2);

r=sqrt(x.^2+y.^2);
alpha=acos( (l1^2+l2^2-r.^2)/(2*l1*l2) );
beta=acos( (r.^2+l1^2-l2^2)./(2*l1*r) );
N=length(x);
theta1=zeros(N,1);
theta2=zeros(N,1);

for i=1:N
   theta2(i)=real(pi-alpha(i)); % always in [0,pi]
   theta1(i)=real(atan2(y(i),x(i))-beta(i));
end
 
% Angular coordinates
Ang(:,1)=theta1;
Ang(:,2)=theta2;