function output = GenEndPoint_nonlinear_2_dof(input)

xf = input.phase.finalstate;
ns=input.auxdata.ns;
Qf=input.auxdata.Qf;

mf=xf(1:ns)';
cf=xf(ns+1:end)';

% final posture
q1=mf(1);
q2=mf(2);
  
% final arm's Jacobian
Jac=[ -(7*sin(q1 + q2))/20 - (3*sin(q1))/10, -(7*sin(q1 + q2))/20 ; ...
      (7*cos(q1 + q2))/20 + (3*cos(q1))/10,  (7*cos(q1 + q2))/20];
  
% final covariance
Pupper = triu(ones(ns));
Pupper(Pupper==1) = cf;   
Pf=(Pupper+Pupper')-bsxfun(@times,eye(size(Pupper)),diag(Pupper)); % full covariance of final state
    
Vq=Pf(1:2,1:2); % Joint-space covariance in q1,q2
Vx=Jac*Vq*Jac'; % Cartesian-space covariance in x,y
Qfel=diag(Qf);

% Cost function with terminal cost
output.objective = input.phase.integral + input.auxdata.rescale*(Qfel(1:2)'*diag(Vx)) ; 


