function [ xellip,yellip ] = confidenceEllipse( xCoP,yCoP )

% in general : sXX = chi2inv(0.XX,2)
s90=4.605;
s0=1; % just the standard deviation

% select the level
schi2=s90;

% center the data
mux=mean(xCoP);
muy=mean(yCoP);
x0=xCoP-mux;
y0=yCoP-muy;

% do PCA
[coef,~,latent]=pca([x0 y0]);

% Std along main axes
sigma1=sqrt(latent(1)); % std along major axis
sigma2=sqrt(latent(2)); % std along minor axis

% lengths of confidence ellipse axes
l1=sqrt(schi2)*sigma1;
l2=sqrt(schi2)*sigma2;

% ellipse in principal axes coordinates
theta=0:0.01:2*pi;
el1=l1*cos(theta); 
el2=l2*sin(theta); 

% rotate
xyel=(coef*[el1 ; el2])';

% translate for the correct centroid
xellip=xyel(:,1)+mux;
yellip=xyel(:,2)+muy;


end


