function pp = interpolate(varargin)
% taken from interp1's matlab function

% X and V should be vectors of equal length
X = varargin{1};
V = varargin{2};
if isvector(V)
    orig_size_v = size(V);
    V = V(:); % Reorient not considered a resize
else
    orig_size_v = size(V);
    n = orig_size_v(1);
    ds = orig_size_v(2:end);
    prodDs = prod(ds);
    V = reshape(V,[n prodDs]);
end

X = X(:);
if isscalar(X)
    error(message('MATLAB:interp1:NotEnoughPts'))
end
if any(diff(X)<0)
    [X, idx] = sort(X);
    V = V(idx,:);
end
   
n = size(V,1);
ds = 1;
prodDs = 1;
if ~isvector(V)
    ds = orig_size_v(2:end);
    prodDs = size(V,2);
end

breaks = X.';
page1 = (diff(V)./repmat(diff(X),[1, prodDs])).';
page2 = (reshape(V(1:end-1,:),[n-1, prodDs])).';
coefs = cat(3,page1,page2);
pp = mkpp(breaks,coefs,ds);

end

